#include <iostream>
#include <omp.h> // OpenMP编程需要包含的头文件

int paraSum() {
    int sum = 0;
    #pragma omp parallel for
    for (int i = 0; i < 5; ++i) {
        sum = sum + i;
    }
    return sum;
}

int paraSumRed() {
    int sum = 0;
//    std::cout << "Before: " << sum << std::endl;
    #pragma omp parallel for reduction(+:sum)
    for (int i = 0; i < 5; ++i) {
        sum = sum + i;
//        std::cout << sum << std::endl;
    }
//    std::cout << "After: " << sum << std::endl;
    return sum;
}

int paraSumRedIO() {
    int sum = 0;
    std::cout << "Before: " << sum << std::endl;
    #pragma omp parallel for reduction(+:sum)
    for (int i = 0; i < 5; ++i) {
        sum = sum + i;
        std::cout << sum << std::endl;
    }
    std::cout << "After: " << sum << std::endl;
    return sum;
}

int main() {
//    int clicks = 1000000;
//    int count = 0;
//    for (int z = 0; z < clicks; z++) {
//        //int sum = paraSum();
//        int sum = paraSumRed();
//        if (sum == 10)
//            count++;
//    }
//    std::cout<<(double)count/clicks<<std::endl;
    paraSumRedIO();
    return 0;
}
